// Copyright (C) 2017 James Jonathan Cook
// This program is distributed under the terms of the GNU Lesser General Public License.
//
// This program was written by James Jonathan Cook (jmsck55@gmail.com)
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Lesser General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include <stdio.h>
#include <stdlib.h>

#include <pthread.h>
//#include <windows.h>

#include "euthread.c"

euthread_function(MyThreadFunction, lpParameter);

//#define new_mutex(NAME) pthread_mutex_t NAME = PTHREAD_MUTEX_INITIALIZER
//#define new_mutex(NAME) CRITICAL_SECTION NAME

new_mutex(CriticalSection);
int counter = 0;

int main() {
	pthread_t ThreadId1, ThreadId2;
	int hThread1, hThread2;
	foo();
	//int rc1, rc2;
	//pthread_t thread1, thread2;
	printf("This is testmain.c\n");

	// Initialize the critical section one time only.
	if (!InitializeCriticalSectionAndSpinCount(&CriticalSection, 0x00000400) ) {
		printf("Cannot initialize critical section.\n");
	    return 0; }
printf("Compiled OK.\n");
   /* Create independent threads each of which will execute functionC */
	
	hThread1 = createThread(&ThreadId1, MyThreadFunction, NULL);
	if(hThread1 < 0)
	{
		printf("Thread creation failed: %d\n", hThread1);
		exit(2);
		//ExitProcess(2);
	}
	hThread2 = createThread(&ThreadId2, MyThreadFunction, NULL);
	if(hThread2 < 0)
	{
		printf("Thread creation failed: %d\n", hThread2);
		exit(2);
		//ExitProcess(2);
	}

   /* Wait till threads are complete before main continues. Unless we  */
   /* wait we run the risk of executing an exit which will terminate   */
   /* the process and all threads before the threads have completed.   */

//See also: "MsgWaitForMultipleObjectsEx"
	joinThread(hThread1, NULL);
	joinThread(hThread2, NULL);
	
	CloseHandle((HANDLE)hThread1);
	CloseHandle((HANDLE)hThread2);
	
	// Release resources used by the critical section object.
	DeleteCriticalSection(&CriticalSection);

FreeLibary(kernel32);

puts("Success!\n");
getc(stdin);
return 0;
}

euthread_function(MyThreadFunction, lpParameter)
{
	// Request ownership of the critical section.
	lockSection(&CriticalSection); 
	
	counter++;
	printf("Counter value: %d\n",counter);
   
	// Release ownership of the critical section.
	unlockSection(&CriticalSection);

return 0;
}
q
