// Copyright (C) 2017 James Jonathan Cook
// This program is distributed under the terms of the GNU Lesser General Public License.
//
// This program was written by James Jonathan Cook (jmsck55@gmail.com)
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Lesser General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef euthread_h__
#define euthread_h__


#ifdef _PTHREAD_NULL_THREAD

#include "euthreadpthread.c"

#else
#ifdef _WINDOWS_

#include "euthreadwin.c"

#endif
#endif



#ifdef __cplusplus
extern "C" {
#endif

//extern void foo(void);

//extern

// put functions here, to be exported when compiled into dll.

#ifdef __cplusplus
}
#endif

#endif // euthread_h__
