// Copyright (C) 2017 James Jonathan Cook
// This program is distributed under the terms of the GNU Lesser General Public License.
//
// This program was written by James Jonathan Cook (jmsck55@gmail.com)
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Lesser General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include <stdio.h>
#include <stdlib.h>

//#include <pthread.h>

#include <windows.h>

int main() {

#ifdef _WINDOWS_
printf("Windows!\n");
printf("sizeof(CRITICAL_SECTION) = %d\n", sizeof(CRITICAL_SECTION)); // 24
printf("sizeof(CONDITION_VARIABLE) = %d\n", sizeof(CONDITION_VARIABLE)); // 4
printf("STACK_SIZE_PARAM_IS_A_RESERVATION = %d\n", STACK_SIZE_PARAM_IS_A_RESERVATION);
printf("INFINITE = %d\n", INFINITE);
#endif

#ifdef _PTHREAD_NULL_THREAD
printf("Pthread!\n");
#endif


return 0;
}
